<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand-0.7.3/src/seq/index.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>index.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Low-level API for sampling indices</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span> <span class="kw">use</span> <span class="ident">core</span>::<span class="ident">slice</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)))]</span>
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">alloc</span>::<span class="ident">vec</span>::{<span class="self">self</span>, <span class="ident">Vec</span>};
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">use</span> <span class="ident">std</span>::<span class="ident">vec</span>;
<span class="comment">// BTreeMap is not as fast in tests, but better than nothing.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)))]</span>
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">alloc</span>::<span class="ident">collections</span>::<span class="ident">BTreeSet</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">use</span> <span class="ident">std</span>::<span class="ident">collections</span>::<span class="ident">HashSet</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::{<span class="ident">uniform</span>::<span class="ident">SampleUniform</span>, <span class="ident">Distribution</span>, <span class="ident">Uniform</span>};
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;

<span class="doccomment">/// A vector of indices.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Multiple internal representations are possible.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">IndexVec</span> {
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">U32</span>(<span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>),
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">USize</span>(<span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>),
}

<span class="kw">impl</span> <span class="ident">IndexVec</span> {
    <span class="doccomment">/// Returns the number of indices</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">len</span>(),
            <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">len</span>(),
        }
    }

    <span class="doccomment">/// Returns `true` if the length is 0.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_empty</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">is_empty</span>(),
            <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">is_empty</span>(),
        }
    }

    <span class="doccomment">/// Return the value at the given `index`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// (Note: we cannot implement [`std::ops::Index`] because of lifetime</span>
    <span class="doccomment">/// restrictions.)</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">index</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>[<span class="ident">index</span>] <span class="kw">as</span> <span class="ident">usize</span>,
            <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>[<span class="ident">index</span>],
        }
    }

    <span class="doccomment">/// Return result as a `Vec&lt;usize&gt;`. Conversion may or may not be trivial.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">into_vec</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">into_iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> <span class="ident">i</span> <span class="kw">as</span> <span class="ident">usize</span>).<span class="ident">collect</span>(),
            <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>,
        }
    }

    <span class="doccomment">/// Iterate over the indices as a sequence of `usize` values</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">IndexVecIter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">IndexVecIter</span>::<span class="ident">U32</span>(<span class="ident">v</span>.<span class="ident">iter</span>()),
            <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">IndexVecIter</span>::<span class="ident">USize</span>(<span class="ident">v</span>.<span class="ident">iter</span>()),
        }
    }

    <span class="doccomment">/// Convert into an iterator over the indices as a sequence of `usize` values</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">into_iter</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">IndexVecIntoIter</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">IndexVecIntoIter</span>::<span class="ident">U32</span>(<span class="ident">v</span>.<span class="ident">into_iter</span>()),
            <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">IndexVecIntoIter</span>::<span class="ident">USize</span>(<span class="ident">v</span>.<span class="ident">into_iter</span>()),
        }
    }
}

<span class="kw">impl</span> <span class="ident">PartialEq</span> <span class="kw">for</span> <span class="ident">IndexVec</span> {
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">other</span>: <span class="kw-2">&amp;</span><span class="ident">IndexVec</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw">use</span> <span class="self">self</span>::<span class="ident">IndexVec</span>::<span class="kw-2">*</span>;
        <span class="kw">match</span> (<span class="self">self</span>, <span class="ident">other</span>) {
            (<span class="kw-2">&amp;</span><span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v1</span>), <span class="kw-2">&amp;</span><span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v2</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v1</span> <span class="op">=</span><span class="op">=</span> <span class="ident">v2</span>,
            (<span class="kw-2">&amp;</span><span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v1</span>), <span class="kw-2">&amp;</span><span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v2</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v1</span> <span class="op">=</span><span class="op">=</span> <span class="ident">v2</span>,
            (<span class="kw-2">&amp;</span><span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v1</span>), <span class="kw-2">&amp;</span><span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v2</span>)) <span class="op">=</span><span class="op">&gt;</span> {
                (<span class="ident">v1</span>.<span class="ident">len</span>() <span class="op">=</span><span class="op">=</span> <span class="ident">v2</span>.<span class="ident">len</span>()) <span class="kw-2">&amp;</span><span class="op">&amp;</span> (<span class="ident">v1</span>.<span class="ident">iter</span>().<span class="ident">zip</span>(<span class="ident">v2</span>.<span class="ident">iter</span>()).<span class="ident">all</span>(<span class="op">|</span>(<span class="ident">x</span>, <span class="ident">y</span>)<span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">=</span><span class="op">=</span> <span class="kw-2">*</span><span class="ident">y</span>))
            }
            (<span class="kw-2">&amp;</span><span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v1</span>), <span class="kw-2">&amp;</span><span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v2</span>)) <span class="op">=</span><span class="op">&gt;</span> {
                (<span class="ident">v1</span>.<span class="ident">len</span>() <span class="op">=</span><span class="op">=</span> <span class="ident">v2</span>.<span class="ident">len</span>()) <span class="kw-2">&amp;</span><span class="op">&amp;</span> (<span class="ident">v1</span>.<span class="ident">iter</span>().<span class="ident">zip</span>(<span class="ident">v2</span>.<span class="ident">iter</span>()).<span class="ident">all</span>(<span class="op">|</span>(<span class="ident">x</span>, <span class="ident">y</span>)<span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="op">=</span><span class="op">=</span> <span class="kw-2">*</span><span class="ident">y</span> <span class="kw">as</span> <span class="ident">usize</span>))
            }
        }
    }
}

<span class="kw">impl</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">IndexVec</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">v</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">IndexVec</span>::<span class="ident">U32</span>(<span class="ident">v</span>)
    }
}

<span class="kw">impl</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">IndexVec</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">v</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">IndexVec</span>::<span class="ident">USize</span>(<span class="ident">v</span>)
    }
}

<span class="doccomment">/// Return type of `IndexVec::iter`.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">IndexVecIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">U32</span>(<span class="ident">slice</span>::<span class="ident">Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">u32</span><span class="op">&gt;</span>),
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">USize</span>(<span class="ident">slice</span>::<span class="ident">Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">usize</span><span class="op">&gt;</span>),
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">IndexVecIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">use</span> <span class="self">self</span>::<span class="ident">IndexVecIter</span>::<span class="kw-2">*</span>;
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="kw-2">mut</span> <span class="ident">iter</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">iter</span>.<span class="ident">next</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">i</span> <span class="kw">as</span> <span class="ident">usize</span>),
            <span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="kw-2">mut</span> <span class="ident">iter</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">iter</span>.<span class="ident">next</span>().<span class="ident">cloned</span>(),
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">size_hint</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">usize</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">IndexVecIter</span>::<span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">size_hint</span>(),
            <span class="ident">IndexVecIter</span>::<span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">size_hint</span>(),
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">ExactSizeIterator</span> <span class="kw">for</span> <span class="ident">IndexVecIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {}

<span class="doccomment">/// Return type of `IndexVec::into_iter`.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">IndexVecIntoIter</span> {
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">U32</span>(<span class="ident">vec</span>::<span class="ident">IntoIter</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>),
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="ident">USize</span>(<span class="ident">vec</span>::<span class="ident">IntoIter</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>),
}

<span class="kw">impl</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">IndexVecIntoIter</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="self">Self</span>::<span class="ident">Item</span><span class="op">&gt;</span> {
        <span class="kw">use</span> <span class="self">self</span>::<span class="ident">IndexVecIntoIter</span>::<span class="kw-2">*</span>;
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="kw-2">mut</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">next</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> <span class="ident">i</span> <span class="kw">as</span> <span class="ident">usize</span>),
            <span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="kw-2">mut</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">next</span>(),
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">size_hint</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">usize</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) {
        <span class="kw">use</span> <span class="self">self</span>::<span class="ident">IndexVecIntoIter</span>::<span class="kw-2">*</span>;
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">U32</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">size_hint</span>(),
            <span class="ident">USize</span>(<span class="kw-2">ref</span> <span class="ident">v</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">v</span>.<span class="ident">size_hint</span>(),
        }
    }
}

<span class="kw">impl</span> <span class="ident">ExactSizeIterator</span> <span class="kw">for</span> <span class="ident">IndexVecIntoIter</span> {}


<span class="doccomment">/// Randomly sample exactly `amount` distinct indices from `0..length`, and</span>
<span class="doccomment">/// return them in random order (fully shuffled).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This method is used internally by the slice sampling methods, but it can</span>
<span class="doccomment">/// sometimes be useful to have the indices themselves so this is provided as</span>
<span class="doccomment">/// an alternative.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The implementation used is not specified; we automatically select the</span>
<span class="doccomment">/// fastest available algorithm for the `length` and `amount` parameters</span>
<span class="doccomment">/// (based on detailed profiling on an Intel Haswell CPU). Roughly speaking,</span>
<span class="doccomment">/// complexity is `O(amount)`, except that when `amount` is small, performance</span>
<span class="doccomment">/// is closer to `O(amount^2)`, and when `length` is close to `amount` then</span>
<span class="doccomment">/// `O(length)`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that performance is significantly better over `u32` indices than over</span>
<span class="doccomment">/// `u64` indices. Because of this we hide the underlying type behind an</span>
<span class="doccomment">/// abstraction, `IndexVec`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If an allocation-free `no_std` function is required, it is suggested</span>
<span class="doccomment">/// to adapt the internal `sample_floyd` implementation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Panics if `amount &gt; length`.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sample</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>, <span class="ident">length</span>: <span class="ident">usize</span>, <span class="ident">amount</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">IndexVec</span>
<span class="kw">where</span> <span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span> {
    <span class="kw">if</span> <span class="ident">amount</span> <span class="op">&gt;</span> <span class="ident">length</span> {
        <span class="macro">panic</span><span class="macro">!</span>(<span class="string">&quot;`amount` of samples must be less than or equal to `length`&quot;</span>);
    }
    <span class="kw">if</span> <span class="ident">length</span> <span class="op">&gt;</span> (::<span class="ident">core</span>::<span class="ident">u32</span>::<span class="ident">MAX</span> <span class="kw">as</span> <span class="ident">usize</span>) {
        <span class="comment">// We never want to use inplace here, but could use floyd&#39;s alg</span>
        <span class="comment">// Lazy version: always use the cache alg.</span>
        <span class="kw">return</span> <span class="ident">sample_rejection</span>(<span class="ident">rng</span>, <span class="ident">length</span>, <span class="ident">amount</span>);
    }
    <span class="kw">let</span> <span class="ident">amount</span> <span class="op">=</span> <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">u32</span>;
    <span class="kw">let</span> <span class="ident">length</span> <span class="op">=</span> <span class="ident">length</span> <span class="kw">as</span> <span class="ident">u32</span>;

    <span class="comment">// Choice of algorithm here depends on both length and amount. See:</span>
    <span class="comment">// https://github.com/rust-random/rand/pull/479</span>
    <span class="comment">// We do some calculations with f32. Accuracy is not very important.</span>

    <span class="kw">if</span> <span class="ident">amount</span> <span class="op">&lt;</span> <span class="number">163</span> {
        <span class="kw">const</span> <span class="ident">C</span>: [[<span class="ident">f32</span>; <span class="number">2</span>]; <span class="number">2</span>] <span class="op">=</span> [[<span class="number">1.6</span>, <span class="number">8.0</span> <span class="op">/</span> <span class="number">45.0</span>], [<span class="number">10.0</span>, <span class="number">70.0</span> <span class="op">/</span> <span class="number">9.0</span>]];
        <span class="kw">let</span> <span class="ident">j</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">length</span> <span class="op">&lt;</span> <span class="number">500_000</span> { <span class="number">0</span> } <span class="kw">else</span> { <span class="number">1</span> };
        <span class="kw">let</span> <span class="ident">amount_fp</span> <span class="op">=</span> <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">f32</span>;
        <span class="kw">let</span> <span class="ident">m4</span> <span class="op">=</span> <span class="ident">C</span>[<span class="number">0</span>][<span class="ident">j</span>] <span class="op">*</span> <span class="ident">amount_fp</span>;
        <span class="comment">// Short-cut: when amount &lt; 12, floyd&#39;s is always faster</span>
        <span class="kw">if</span> <span class="ident">amount</span> <span class="op">&gt;</span> <span class="number">11</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> (<span class="ident">length</span> <span class="kw">as</span> <span class="ident">f32</span>) <span class="op">&lt;</span> (<span class="ident">C</span>[<span class="number">1</span>][<span class="ident">j</span>] <span class="op">+</span> <span class="ident">m4</span>) <span class="op">*</span> <span class="ident">amount_fp</span> {
            <span class="ident">sample_inplace</span>(<span class="ident">rng</span>, <span class="ident">length</span>, <span class="ident">amount</span>)
        } <span class="kw">else</span> {
            <span class="ident">sample_floyd</span>(<span class="ident">rng</span>, <span class="ident">length</span>, <span class="ident">amount</span>)
        }
    } <span class="kw">else</span> {
        <span class="kw">const</span> <span class="ident">C</span>: [<span class="ident">f32</span>; <span class="number">2</span>] <span class="op">=</span> [<span class="number">270.0</span>, <span class="number">330.0</span> <span class="op">/</span> <span class="number">9.0</span>];
        <span class="kw">let</span> <span class="ident">j</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">length</span> <span class="op">&lt;</span> <span class="number">500_000</span> { <span class="number">0</span> } <span class="kw">else</span> { <span class="number">1</span> };
        <span class="kw">if</span> (<span class="ident">length</span> <span class="kw">as</span> <span class="ident">f32</span>) <span class="op">&lt;</span> <span class="ident">C</span>[<span class="ident">j</span>] <span class="op">*</span> (<span class="ident">amount</span> <span class="kw">as</span> <span class="ident">f32</span>) {
            <span class="ident">sample_inplace</span>(<span class="ident">rng</span>, <span class="ident">length</span>, <span class="ident">amount</span>)
        } <span class="kw">else</span> {
            <span class="ident">sample_rejection</span>(<span class="ident">rng</span>, <span class="ident">length</span>, <span class="ident">amount</span>)
        }
    }
}

<span class="doccomment">/// Randomly sample exactly `amount` indices from `0..length`, using Floyd&#39;s</span>
<span class="doccomment">/// combination algorithm.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The output values are fully shuffled. (Overhead is under 50%.)</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This implementation uses `O(amount)` memory and `O(amount^2)` time.</span>
<span class="kw">fn</span> <span class="ident">sample_floyd</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>, <span class="ident">length</span>: <span class="ident">u32</span>, <span class="ident">amount</span>: <span class="ident">u32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">IndexVec</span>
<span class="kw">where</span> <span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span> {
    <span class="comment">// For small amount we use Floyd&#39;s fully-shuffled variant. For larger</span>
    <span class="comment">// amounts this is slow due to Vec::insert performance, so we shuffle</span>
    <span class="comment">// afterwards. Benchmarks show little overhead from extra logic.</span>
    <span class="kw">let</span> <span class="ident">floyd_shuffle</span> <span class="op">=</span> <span class="ident">amount</span> <span class="op">&lt;</span> <span class="number">50</span>;

    <span class="macro">debug_assert</span><span class="macro">!</span>(<span class="ident">amount</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">length</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">indices</span> <span class="op">=</span> <span class="ident">Vec</span>::<span class="ident">with_capacity</span>(<span class="ident">amount</span> <span class="kw">as</span> <span class="ident">usize</span>);
    <span class="kw">for</span> <span class="ident">j</span> <span class="kw">in</span> <span class="ident">length</span> <span class="op">-</span> <span class="ident">amount</span>..<span class="ident">length</span> {
        <span class="kw">let</span> <span class="ident">t</span> <span class="op">=</span> <span class="ident">rng</span>.<span class="ident">gen_range</span>(<span class="number">0</span>, <span class="ident">j</span> <span class="op">+</span> <span class="number">1</span>);
        <span class="kw">if</span> <span class="ident">floyd_shuffle</span> {
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">pos</span>) <span class="op">=</span> <span class="ident">indices</span>.<span class="ident">iter</span>().<span class="ident">position</span>(<span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span> <span class="op">=</span><span class="op">=</span> <span class="ident">t</span>) {
                <span class="ident">indices</span>.<span class="ident">insert</span>(<span class="ident">pos</span>, <span class="ident">j</span>);
                <span class="kw">continue</span>;
            }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">indices</span>.<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="ident">t</span>) {
            <span class="ident">indices</span>.<span class="ident">push</span>(<span class="ident">j</span>);
            <span class="kw">continue</span>;
        }
        <span class="ident">indices</span>.<span class="ident">push</span>(<span class="ident">t</span>);
    }
    <span class="kw">if</span> <span class="op">!</span><span class="ident">floyd_shuffle</span> {
        <span class="comment">// Reimplement SliceRandom::shuffle with smaller indices</span>
        <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> (<span class="number">1</span>..<span class="ident">amount</span>).<span class="ident">rev</span>() {
            <span class="comment">// invariant: elements with index &gt; i have been locked in place.</span>
            <span class="ident">indices</span>.<span class="ident">swap</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">rng</span>.<span class="ident">gen_range</span>(<span class="number">0</span>, <span class="ident">i</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">usize</span>);
        }
    }
    <span class="ident">IndexVec</span>::<span class="ident">from</span>(<span class="ident">indices</span>)
}

<span class="doccomment">/// Randomly sample exactly `amount` indices from `0..length`, using an inplace</span>
<span class="doccomment">/// partial Fisher-Yates method.</span>
<span class="doccomment">/// Sample an amount of indices using an inplace partial fisher yates method.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This allocates the entire `length` of indices and randomizes only the first `amount`.</span>
<span class="doccomment">/// It then truncates to `amount` and returns.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This method is not appropriate for large `length` and potentially uses a lot</span>
<span class="doccomment">/// of memory; because of this we only implement for `u32` index (which improves</span>
<span class="doccomment">/// performance in all cases).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Set-up is `O(length)` time and memory and shuffling is `O(amount)` time.</span>
<span class="kw">fn</span> <span class="ident">sample_inplace</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>, <span class="ident">length</span>: <span class="ident">u32</span>, <span class="ident">amount</span>: <span class="ident">u32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">IndexVec</span>
<span class="kw">where</span> <span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span> {
    <span class="macro">debug_assert</span><span class="macro">!</span>(<span class="ident">amount</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">length</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">indices</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Vec</span>::<span class="ident">with_capacity</span>(<span class="ident">length</span> <span class="kw">as</span> <span class="ident">usize</span>);
    <span class="ident">indices</span>.<span class="ident">extend</span>(<span class="number">0</span>..<span class="ident">length</span>);
    <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">amount</span> {
        <span class="kw">let</span> <span class="ident">j</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident">rng</span>.<span class="ident">gen_range</span>(<span class="ident">i</span>, <span class="ident">length</span>);
        <span class="ident">indices</span>.<span class="ident">swap</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">j</span> <span class="kw">as</span> <span class="ident">usize</span>);
    }
    <span class="ident">indices</span>.<span class="ident">truncate</span>(<span class="ident">amount</span> <span class="kw">as</span> <span class="ident">usize</span>);
    <span class="macro">debug_assert_eq</span><span class="macro">!</span>(<span class="ident">indices</span>.<span class="ident">len</span>(), <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">usize</span>);
    <span class="ident">IndexVec</span>::<span class="ident">from</span>(<span class="ident">indices</span>)
}

<span class="kw">trait</span> <span class="ident">UInt</span>: <span class="ident">Copy</span> <span class="op">+</span> <span class="ident">PartialOrd</span> <span class="op">+</span> <span class="ident">Ord</span> <span class="op">+</span> <span class="ident">PartialEq</span> <span class="op">+</span> <span class="ident">Eq</span> <span class="op">+</span> <span class="ident">SampleUniform</span> <span class="op">+</span> <span class="ident">core</span>::<span class="ident">hash</span>::<span class="ident">Hash</span> {
    <span class="kw">fn</span> <span class="ident">zero</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span>;
    <span class="kw">fn</span> <span class="ident">as_usize</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span>;
}
<span class="kw">impl</span> <span class="ident">UInt</span> <span class="kw">for</span> <span class="ident">u32</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">zero</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="number">0</span>
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">as_usize</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span> <span class="kw">as</span> <span class="ident">usize</span>
    }
}
<span class="kw">impl</span> <span class="ident">UInt</span> <span class="kw">for</span> <span class="ident">usize</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">zero</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="number">0</span>
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">as_usize</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span>
    }
}

<span class="doccomment">/// Randomly sample exactly `amount` indices from `0..length`, using rejection</span>
<span class="doccomment">/// sampling.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Since `amount &lt;&lt;&lt; length` there is a low chance of a random sample in</span>
<span class="doccomment">/// `0..length` being a duplicate. We test for duplicates and resample where</span>
<span class="doccomment">/// necessary. The algorithm is `O(amount)` time and memory.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function  is generic over X primarily so that results are value-stable</span>
<span class="doccomment">/// over 32-bit and 64-bit platforms.</span>
<span class="kw">fn</span> <span class="ident">sample_rejection</span><span class="op">&lt;</span><span class="ident">X</span>: <span class="ident">UInt</span>, <span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>, <span class="ident">length</span>: <span class="ident">X</span>, <span class="ident">amount</span>: <span class="ident">X</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">IndexVec</span>
<span class="kw">where</span>
    <span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span>,
    <span class="ident">IndexVec</span>: <span class="ident">From</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">X</span><span class="op">&gt;</span><span class="op">&gt;</span>,
{
    <span class="macro">debug_assert</span><span class="macro">!</span>(<span class="ident">amount</span> <span class="op">&lt;</span> <span class="ident">length</span>);
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cache</span> <span class="op">=</span> <span class="ident">HashSet</span>::<span class="ident">with_capacity</span>(<span class="ident">amount</span>.<span class="ident">as_usize</span>());
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cache</span> <span class="op">=</span> <span class="ident">BTreeSet</span>::<span class="ident">new</span>();
    <span class="kw">let</span> <span class="ident">distr</span> <span class="op">=</span> <span class="ident">Uniform</span>::<span class="ident">new</span>(<span class="ident">X</span>::<span class="ident">zero</span>(), <span class="ident">length</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">indices</span> <span class="op">=</span> <span class="ident">Vec</span>::<span class="ident">with_capacity</span>(<span class="ident">amount</span>.<span class="ident">as_usize</span>());
    <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">amount</span>.<span class="ident">as_usize</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">pos</span> <span class="op">=</span> <span class="ident">distr</span>.<span class="ident">sample</span>(<span class="ident">rng</span>);
        <span class="kw">while</span> <span class="op">!</span><span class="ident">cache</span>.<span class="ident">insert</span>(<span class="ident">pos</span>) {
            <span class="ident">pos</span> <span class="op">=</span> <span class="ident">distr</span>.<span class="ident">sample</span>(<span class="ident">rng</span>);
        }
        <span class="ident">indices</span>.<span class="ident">push</span>(<span class="ident">pos</span>);
    }

    <span class="macro">debug_assert_eq</span><span class="macro">!</span>(<span class="ident">indices</span>.<span class="ident">len</span>(), <span class="ident">amount</span>.<span class="ident">as_usize</span>());
    <span class="ident">IndexVec</span>::<span class="ident">from</span>(<span class="ident">indices</span>)
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)))]</span> <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">alloc</span>::<span class="ident">vec</span>;
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">use</span> <span class="ident">std</span>::<span class="ident">vec</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_sample_boundaries</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">r</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">404</span>);

        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_inplace</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">0</span>, <span class="number">0</span>).<span class="ident">len</span>(), <span class="number">0</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_inplace</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1</span>, <span class="number">0</span>).<span class="ident">len</span>(), <span class="number">0</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_inplace</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1</span>, <span class="number">1</span>).<span class="ident">into_vec</span>(), <span class="macro">vec</span><span class="macro">!</span>[<span class="number">0</span>]);

        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_rejection</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1u32</span>, <span class="number">0</span>).<span class="ident">len</span>(), <span class="number">0</span>);

        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_floyd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">0</span>, <span class="number">0</span>).<span class="ident">len</span>(), <span class="number">0</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_floyd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1</span>, <span class="number">0</span>).<span class="ident">len</span>(), <span class="number">0</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">sample_floyd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1</span>, <span class="number">1</span>).<span class="ident">into_vec</span>(), <span class="macro">vec</span><span class="macro">!</span>[<span class="number">0</span>]);

        <span class="comment">// These algorithms should be fast with big numbers. Test average.</span>
        <span class="kw">let</span> <span class="ident">sum</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">sample_rejection</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">25</span>, <span class="number">10u32</span>).<span class="ident">into_iter</span>().<span class="ident">sum</span>();
        <span class="macro">assert</span><span class="macro">!</span>(<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">25</span> <span class="op">&lt;</span> <span class="ident">sum</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> <span class="ident">sum</span> <span class="op">&lt;</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">25</span>) <span class="op">*</span> <span class="number">25</span>);

        <span class="kw">let</span> <span class="ident">sum</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">sample_floyd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">r</span>, <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">25</span>, <span class="number">10</span>).<span class="ident">into_iter</span>().<span class="ident">sum</span>();
        <span class="macro">assert</span><span class="macro">!</span>(<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">25</span> <span class="op">&lt;</span> <span class="ident">sum</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> <span class="ident">sum</span> <span class="op">&lt;</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">25</span>) <span class="op">*</span> <span class="number">25</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">miri</span>, <span class="ident">ignore</span>)]</span> <span class="comment">// Miri is too slow</span>
    <span class="kw">fn</span> <span class="ident">test_sample_alg</span>() {
        <span class="kw">let</span> <span class="ident">seed_rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>;

        <span class="comment">// We can&#39;t test which algorithm is used directly, but Floyd&#39;s alg</span>
        <span class="comment">// should produce different results from the others. (Also, `inplace`</span>
        <span class="comment">// and `cached` currently use different sizes thus produce different results.)</span>

        <span class="comment">// A small length and relatively large amount should use inplace</span>
        <span class="kw">let</span> (<span class="ident">length</span>, <span class="ident">amount</span>): (<span class="ident">usize</span>, <span class="ident">usize</span>) <span class="op">=</span> (<span class="number">100</span>, <span class="number">50</span>);
        <span class="kw">let</span> <span class="ident">v1</span> <span class="op">=</span> <span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">420</span>), <span class="ident">length</span>, <span class="ident">amount</span>);
        <span class="kw">let</span> <span class="ident">v2</span> <span class="op">=</span> <span class="ident">sample_inplace</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">420</span>), <span class="ident">length</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">u32</span>);
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">v1</span>.<span class="ident">iter</span>().<span class="ident">all</span>(<span class="op">|</span><span class="ident">e</span><span class="op">|</span> <span class="ident">e</span> <span class="op">&lt;</span> <span class="ident">length</span>));
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">v1</span>, <span class="ident">v2</span>);

        <span class="comment">// Test Floyd&#39;s alg does produce different results</span>
        <span class="kw">let</span> <span class="ident">v3</span> <span class="op">=</span> <span class="ident">sample_floyd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">420</span>), <span class="ident">length</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">u32</span>);
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">v1</span> <span class="op">!</span><span class="op">=</span> <span class="ident">v3</span>);

        <span class="comment">// A large length and small amount should use Floyd</span>
        <span class="kw">let</span> (<span class="ident">length</span>, <span class="ident">amount</span>): (<span class="ident">usize</span>, <span class="ident">usize</span>) <span class="op">=</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">20</span>, <span class="number">50</span>);
        <span class="kw">let</span> <span class="ident">v1</span> <span class="op">=</span> <span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">421</span>), <span class="ident">length</span>, <span class="ident">amount</span>);
        <span class="kw">let</span> <span class="ident">v2</span> <span class="op">=</span> <span class="ident">sample_floyd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">421</span>), <span class="ident">length</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">u32</span>);
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">v1</span>.<span class="ident">iter</span>().<span class="ident">all</span>(<span class="op">|</span><span class="ident">e</span><span class="op">|</span> <span class="ident">e</span> <span class="op">&lt;</span> <span class="ident">length</span>));
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">v1</span>, <span class="ident">v2</span>);

        <span class="comment">// A large length and larger amount should use cache</span>
        <span class="kw">let</span> (<span class="ident">length</span>, <span class="ident">amount</span>): (<span class="ident">usize</span>, <span class="ident">usize</span>) <span class="op">=</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">20</span>, <span class="number">600</span>);
        <span class="kw">let</span> <span class="ident">v1</span> <span class="op">=</span> <span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">422</span>), <span class="ident">length</span>, <span class="ident">amount</span>);
        <span class="kw">let</span> <span class="ident">v2</span> <span class="op">=</span> <span class="ident">sample_rejection</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">seed_rng</span>(<span class="number">422</span>), <span class="ident">length</span> <span class="kw">as</span> <span class="ident">u32</span>, <span class="ident">amount</span> <span class="kw">as</span> <span class="ident">u32</span>);
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">v1</span>.<span class="ident">iter</span>().<span class="ident">all</span>(<span class="op">|</span><span class="ident">e</span><span class="op">|</span> <span class="ident">e</span> <span class="op">&lt;</span> <span class="ident">length</span>));
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">v1</span>, <span class="ident">v2</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "rand";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>